Subject: Re: cygwin-b20 gcc: "A - floor(A)" returns a negative value
From: [email-masked] (Mumit Khan)

10 Nov 1998 13:40:06 -0800
Message-ID: <[email-masked]>
References: <[email-masked]>
To: "Peter Kabal" <[email-masked]>
Cc: [email-masked]

"Peter Kabal" <[email-masked]> writes:
> Switching from cygwin-b19 to cygwin-b20 caused a C-routine to give
> incorrect results.  This was traced to a calculation (in double) of
> "A - float(A)" which returns a negative value.  By definition it should
> always be positive.  A short test program which demonstrates this
> problem is included.  If the program is further simplified, the problem
> goes away.  To exercise the bug, the program must be compiled with
> optimization level -O3.
> 
> % gcc -O3 tfloor.c -o tfloor
> % ./tfloor
> AV = 20, AV - floor(AV) = -1.11022e-15

The suggestion is to use -ffloat-store to tell egcs not to use the excess
precision in the x86 FP regs. It does give the correct results then.

Thanks for pointing this out. I'm now adding this as a standard flag to
all of our numerical codes.

Regards,
Mumit
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".